/*Animal Farm    (afarm.cc)
UNIX, C++ version by Chris G Busch (cbusch@d.umn.edu)
Original Psion version by mervyn@xs4all.nl
version 2
to compile:
   CC afarm.cc -o afarm -lcurses
to run:
   afarm
*/



//compatibility:

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#ifndef USETEXT
//#define NOMACROS  <-- this line no longer necessary
#include <curses.h>
#endif

void afarm();
void setup();
void mut();
void newpos();
void comp();
void repr();
void Move();
void view();


void initscreen()
{
#ifndef USETEXT
  initscr();
  nonl();
  leaveok(stdscr,1);
//  keypad(stdscr,1);
//  nodelay(stdscr,1);
  refresh();
#endif
}

void uninitscreen()
{
#ifndef USETEXT
  fflush(stdin);
//  nodelay(stdscr,0);
  endwin();
  fflush(stdin);
  fflush(stdout);
#endif
}


void cls()
{
  //curses
#ifndef USETEXT
  clear();
#else
  puts("\nclear\n\n");
#endif
}

double rnd() 
{
  return (rand()%1001)/1000.0;
}

int key=0;

void gline(int,int,int,int) 
{
}

void printat(int x,int y, char* msg)
{
  //curses
#ifdef USETEXT
  printf("%d,%d  %s\n",x,y,msg);
#else
  mvaddstr(y,x,msg);
#endif
}

void printatnum(int x,int y,char* msg,double num)
{
  char str[100]="";
  sprintf(str,msg,num);
#ifndef USETEXT
  mvaddstr(y,x,str);
#else
  printf("%d,%d  %lf\n",x,y,str);
#endif
}



char* chr(char c)
{
  static char str[2];
  if(c>'Z') c='Z';
  str[0]=c; str[1]=0;
  return str;
}

#ifdef USETEXT
void refresh()
{
  puts("\nrefreshed\n\n\n");
}

int getch()
{
  char str[100]="";
  printf("press a key and enter: ");
  gets(str);
  return int(str[0]);
}
#endif

//end compatibility

// PROC Afarm:
// global a%(200),en(200),de%(200),sp%(200),rep%(200)
int ar[200],de[200],sp[200],rep[200];
float en[200];
// global sun,mut%,n%,p%,fs%,ti%,fa%,fl%,fa0%,fl0%,a%,r%,p
// cache 0,3000 :cache on :randomize second :ti%=110 :fs%=100
float sunlight,Pnotused;
int mutint,n,pint,fs=100,ti=110,fa,fl,fa0,fl0,avar,r;

void afarm()
{
  srand(time(NULL));
// SETUP:
 setup();
// do :p%=0 
  do{
    pint=0;
//  do :p%=p%+1 
    do{
      pint+=1;
//      if en(p%)>0 
      if(en[pint]>0) {
// :en(p%)=en(p%)+sunlight-(abs(sp%(p%))+abs(de%(p%))+abs(a%(p%)))
        en[pint]+=sunlight-(abs(sp[pint])+abs(de[pint])+abs(ar[pint]));
//          if en(p%)>rep%(p%) :REPR: :endif
        if(en[pint]>rep[pint]) { repr(); }
//          if sp%(p%)<>0 :NEWPOS:
        if(sp[pint]!=0){
          newpos();
//              if en(n%)<=0 :MOVE: :else COMP: :endif
            if(en[n]<=0) {
              Move();
            }else {
              comp();
            }
//          endif 
        }
//      endif
      }
//  until p%=fs%
    }while(!(pint==fs));
//  VIEW:
    view();
//  if key<>0 :setup: :endif
    key=getch();
    if(key>='0' && key<='9') {
      sunlight=(key-'0')*1.0;
      printatnum(2,12,"new sunlight value: %lf",double(sunlight));
    }else if(key>='A' && key<='Z') {
      r=(key-'A')*4;
      printatnum(2,13,"new mutation risk: %lf",double(r));
    }
// until 0
  }while(key!='q');
// ENDP
}

// PROC setup:
void setup()
{
// en(45)=1 :rep%(45)=2 :rem REProduction E-level 
  en[45]=1; rep[45]=2;
// print "Mervyn's Animal Farm" :print
  puts("Mervyn's Animal Farm");
  puts("converted to C++ by cbusch");
// print "e=energy a=attack d=defense s=speed"
  puts("e=energy a=attack d=defense s=speed");
// print "e=e+sunlight-(a+d+s) [+e(from attacked entity)]"
  puts("e=e+sunlight-(a+d+s) [+e(from attacked entity)]");
// print "specie name: a+4*d+10*s -> 0-25=A-Z"
  puts("specie name: a+4*d+10*s -> 0-25=A-Z");
// print "Sun (free energy):"; :input sun
  puts("Valid keys during the animation are [0..9,A-Z] and q quits");
  printf("Sunlight (free energy) ex 1.9 : ");
  scanf("%f",&sunlight);
// print "Mutation risk (%):"; :input r% :cls
  printf("Mutation risk (%%) ex 5 :"); 
  scanf("%d",&r);
  initscreen();
  cls();
// ENDP
}

// PROC newpos:
void newpos()
{
// a%=rnd*4
  avar=rand()%4;
// if a%=0 :n%=p%-1
  if(avar==0) n=pint-1;
//  elseif a%=1 :n%=p%+1
  else if(avar==1) n=pint+1;
//  elseif a%=2 :n%=p%-10
  else if(avar==2) n=pint-10;
//  elseif a%=3 :n%=p%+10
  else if(avar==3) n=pint+10;
// endif
// if n%<1 :n%=fs% :elseif n%>fs% :n%=1 :endif
  if(n<1) n=fs;
  else if(n>fs) n=1;
// ENDP
}

// PROC Move:
void Move()
{
// en(n%)=en(p%) :a%(n%)=a%(p%) :de%(n%)=de%(p%)
  en[n]=en[pint]; ar[n]=ar[pint]; de[n]=de[pint];
// sp%(n%)=sp%(p%) :rep%(n%)=rep%(p%) :en(p%)=0
  sp[n]=sp[pint]; rep[n]=rep[pint]; en[pint]=0;
// ENDP
}

// PROC comp:
void comp()
{
// if a%(p%)>=de%(n%)
  if(ar[pint]>=de[n]) {
//  en(p%)=en(p%)+en(n%)
    en[pint]=en[pint]+en[n];
//  MOVE:
    Move();
// endif
  }
// ENDP
}

// PROC repr:
void repr()
{
// NEWPOS:
  newpos();
// MUT:
  mut();
// if en(n%)<=0 or de%(p%)+mut%>a%(n%)
  if(en[n]<=0 || de[pint]+mutint>ar[n])  {
//  en(n%)=int(0.5*en(p%))+en(n%)
    en[n]=int(0.5*en[pint])+en[n];
//  en(p%)=int(0.5*en(p%))-(abs(de%(p%))+abs(a%(p%)))
    en[pint]=int(0.5*en[pint])-(abs(de[pint])+abs(ar[pint]));
//  de%(n%)=de%(p%)+mut% 
    de[n]=de[pint]+mutint;
//  mut: :a%(n%)=a%(p%)+mut%
    mut(); ar[n]=ar[pint]+mutint;
//  mut: :sp%(n%)=sp%(p%)+mut%
    mut(); ar[n]=ar[pint]+mutint;
//  mut: :rep%(n%)=rep%(p%)+mut%
    mut(); rep[n]=rep[pint]+mutint;
// endif
  }
// ENDP
}

// PROC mut:
void mut()
{
// mut%=rnd*100
  mutint=rand()%100;
// if mut%<r%
  if(mutint<r) {
//  mut%=-2+rnd*4
    mutint=-1+(rand()%4);
//  else mut%=0
  }else {
    mutint=0;
// endif
  }
// ENDP
}

// PROC view:
void view()
{
// local x%,y%,t%
  int x,y,t;
// at 15,2 :print "Animal Farm  by  Mervyn"
  printat(15,2,"Animal Farm  by  Mervyn");
  printat(15,17,"q     quits");
  printat(15,18,"1..9  changes sunlight");
  printat(15,19,"A..Z  changes mutation risk");
// y%=1 :fl%=0 :fa%=0 :ti%=ti%+1
  y=1; fl=0; fa=0; ti++;
// do :x%=0
  do{ 
    x=0;
//  do :x%=x%+1 :t%=x%+(y%-1)*10
    do{
      x++; t=x+(y-1)*10;
//      if en(t%)>0
      if(en[t]>0) {
//          if sp%(t%)<>0 :fa%=fa%+1 :else :fl%=fl%+1 :endif
        if(sp[t]!=0) {
          fa++;
        }else{
          fl++;
        }
//          at x%,y% :print 
        printat(x,y,
// chr$(65+a%(t%)+4*de%(t%)+10*abs(sp%(t%)))
            chr(65+ar[t]+4*de[t]+10*abs(sp[t])));
//          else at x%,y% :print "." 
      }else{
        printat(x,y,".");
//      endif
      }
//  until x%=10
    }while(!( x==10));
//  y%=y%+1
    y++;
// until y%=11
  }while(!(y==11));
// at 15,4 :print "Flora : ";fl%;" "
  printatnum(15,4,"Flora : %lf ",fl);
// at 15,5 :print "Fauna : ";fa%;" "
  printatnum(15,5,"Fauna : %lf ",fa);
// gAt ti%,150-fa0% :gLineto ti%+1,150-fa%
  gline(ti,150-fa0,ti+1,150-fa);
// gAt ti%,150-fl0% :gLineto ti%+1,150-fl%
  gline(ti,150-fl0,ti+1,150-fl);
// fa0%=fa% :fl0%=fl% :if ti%=410 :ti%=110 :cls :endif
  fa0=fa; fl0=fl; 
  if(ti==410) {
    ti=110;
    cls();
  }
// ENDP
  //curses
  refresh();
}

void main()
{
  afarm();
  uninitscreen();
}


